function ave_w=CW_MPLS(data,windowWeight)
% firstly calculate the weight of each spectrum by using mpls
% then the ave_w is obtained from the average of weight vector


%% use MPLS to calculate the weight vector
% windowWeight for mpls parameter setting
if nargin ==1
    windowWeight=50;
end

for j=1:size(data)
x=data(j,:);
Xbg=Morphology(x,windowWeight);
m = length(Xbg);
w = zeros(m, 1);
repeat = 1;
i=1;
Z=[];
xbg_reversel=Xbg(m:-1:1);
temp1=ones(m,1);
temp1(find([1;diff(Xbg, 1)]==0))=0;
temp2=ones(m,1);
temp2(find([1;diff(xbg_reversel, 1)]==0))=0;
temp2_reversel=temp2(m:-1:1);
temp=zeros(m,1);
temp3=temp1+temp2_reversel;
if temp3(2)==0
    temp3(1)=1;
end
temp(find(temp3==1))=1;
index=find(temp==1);
w = zeros(m, 1);
for i=1:floor(length(index)/2)-1
    [M,N]=min(Xbg(index(2*(i-1)+2):index(2*(i)+1)));
    w(index(2*(i-1)+2)+N-1)=1;
end
w(m)=5;
w(1)=5;
w1(j,:)=w';
end

%% calculate the average of weight vector
ave_w=mean(w1);
ave_w=ave_w';
 

