function Xbg=Morphology(X,windowWeight)
% morphology function in mpls
% used to get the rough background

if nargin ==1
    windowWeight=50;
end
Nx=length(X);
if windowWeight >=Nx/2-1
    windowWeight=floor(Nx/2-1);
end

Xerosion=zeros(1,Nx);
Xdilation=zeros(1,Nx);
i=1;

for j=1:windowWeight
    Xerosion(i,j)=min(X(i,1:j+windowWeight));
end
for j=windowWeight+1:(Nx-windowWeight)
    Xerosion(i,j)=min(X(i,j-windowWeight:j+windowWeight));
end
for j=(Nx-windowWeight+1):Nx
    Xerosion(i,j)=min(X(i,j-windowWeight:Nx));
end

for j=1:windowWeight
    Xdilation(i,j)=max(Xerosion(i,1:j+windowWeight));
end
for j=windowWeight+1:(Nx-windowWeight)
    Xdilation(i,j)=max(Xerosion(i,j-windowWeight:j+windowWeight));
end
for j=(Nx-windowWeight+1):Nx
    Xdilation(i,j)=max(Xerosion(i,j-windowWeight:Nx));
end
 Xbg=Xdilation';
 for j=1:windowWeight
    Xdilation(i,j)=max(X(i,1:j+windowWeight));
end
for j=windowWeight+1:(Nx-windowWeight)
    Xdilation(i,j)=max(X(i,j-windowWeight:j+windowWeight));
end
for j=(Nx-windowWeight+1):Nx
    Xdilation(i,j)=max(X(i,j-windowWeight:Nx));
end
Xbg(end-3:end)=X(end-3:end);
end